﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr265_1
{
    // Базовый класс: 
    class Alpha {
        // Целочисленное поле: 
        public int code;
        // Переопределение метода ToString(): 
        public override string ToString() { 
            return "Alpha: " + code;
        }
    }

    // Производный класс: 
    class Bravo: Alpha {
        // Текстовое поле: 
        public string text;
        // Переопределение метода ToString(): 
        public override string ToString() { 
            return "Bravo: " + code + " и " + text;
        }
    }

    // Обобщенный класс: 
    class MyClass<X, Y> 
        where X: class, new() // Ограничения на параметр X 
        where Y: X, new() {	// Ограничения на параметр Y
        // Первое поле обобщенного типа: 
        public X first;
        // Второе поле обобщенного типа: 
        public Y second;
        // Конструктор: 
        public MyClass() {
            // Создаются объекты обобщенных типов: 
            first = new X(); 
            second = new Y();
        }
        // Переопределение метода ToString(): 
        public override string ToString() {
            return "MyClass->|" + first + "|" + second + "|";
        }
    }

    // Главный класс: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создание объекта обобщенного класса:
            MyClass<Alpha, Bravo> obj = new MyClass<Alpha, Bravo>();
            // Присваивание значений полям: 
            obj.first.code = 100; 
            obj.second.code = 200; 
            obj.second.text = "text";
            // Отображение характеристик объекта:
            Console.WriteLine(obj);
            // Задержка:
            Console.ReadLine();
        }
    }
}
